def setupScene():

    light = Light( numpy.array( [ 150.0, 50.0, -500.0 ] ) )
    light2 = Light( numpy.array( [ -150.0, 150.0, -500.0 ] ), 
                    numpy.array( [ 0.7, 0.7, 0.7 ] ) )

    mat_diffuse = numpy.array( [0.1, 0.5, 0.8] )
    mat_specular = numpy.array( [1.0, 1.0, 1.0] )
    mat_shininess = 100.0
    sphere = Sphere( [-40.0, -50.0, -650.5], 40.0, 
                     Material( diffuse = mat_diffuse, specular = mat_specular, 
                               shininess = mat_shininess  ) )

    mat_diffuse2 = numpy.array( [37.0/255.0, 37.0/255.0, 37.0/255.0] )
    mat_specular2 = numpy.array( [1.0, 1.0, 1.0] )
    mat_shininess = 100.0
    sphere2 = Sphere( [80.0, -50.0, -600.5], 40.0, 
                     Material( diffuse = mat_diffuse2, specular = mat_specular2, 
                               shininess = mat_shininess, reflective=True ) )

    skybox = Skybox( filenames, numpy.array( [30.0, -100.0, -650.0 ] ), numpy.array( [130.0, 0.0, -550.0] ) )

#    scene_graph = SceneGraph( [ sphere, sphere2 ] + skybox.faces, [light, light2] )
    scene_graph = SceneGraph( [ sphere2 ] + skybox.faces, [light, light2] )

    return scene_graph

def setupTorusScene():

    skybox = Skybox( filenames, numpy.array( [-230.0, -300.0, -1250.0 ] ), numpy.array( [390.0, 200.0, -350.0] ) )

    mat_diffuse2 = numpy.array( [37.0/255.0, 37.0/255.0, 37.0/255.0] )
    mat_specular2 = numpy.array( [1.0, 1.0, 1.0] )
    mat_shininess = 100.0

#    matrix = rotation_matrix(-math.pi/4.0, [1.0, 0.0, 0.0])
#    matrix = rotation_matrix(  -math.pi * 0.9 / 2.0, [1.0, 0.0, 0.0])[:3, :3]
    matrix = rotation_matrix(  -math.pi * ( 75.0/180.0 ), [1.0, 0.0, 0.0])[:3, :3]
    matrix = numpy.dot( rotation_matrix( math.pi/9.0, [0.0, 0.0, 1.0])[:3, :3], matrix )

    sphere = Sphere( [80.0, -50.0, -600.5], 30.0, 
                     Material( diffuse = mat_diffuse2, specular = mat_specular2, 
                               shininess = mat_shininess, reflective=True ) )

    torus = Torus( 60.0, 10.0, [80.0, -50.0, -600.5],
                     Material( diffuse = mat_diffuse2, specular = mat_specular2, 
                               shininess = mat_shininess, reflective=True ), matrix )
    print torus
    scene_graph = SceneGraph( [ torus, sphere ] + skybox.faces, [] )

    return scene_graph

def setupTorusScene2():
    # this is basically for checking that the normals are correct for the torus, easy to just see from lighting
    light = Light( numpy.array( [ 150.0, 50.0, -500.0 ] ) )
    light2 = Light( numpy.array( [ -150.0, 150.0, -500.0 ] ), 
                    numpy.array( [ 0.7, 0.7, 0.7 ] ) )

    mat_diffuse = numpy.array( [0.1, 0.5, 0.8] )
    mat_specular = numpy.array( [1.0, 1.0, 1.0] )
    mat_shininess = 100.0

    sphere = Sphere( [80.0, -50.0, -600.5], 30.0, 
                     Material( diffuse = mat_diffuse, specular = mat_specular, 
                               shininess = mat_shininess ) )

    matrix = rotation_matrix(  -math.pi * ( 75.0/180.0 ), [1.0, 0.0, 0.0])[:3, :3]
    matrix = numpy.dot( rotation_matrix( math.pi/9.0, [0.0, 0.0, 1.0])[:3, :3], matrix )
    torus = Torus( 60.0, 10.0, [0.0, -50.0, -600.5],
                     Material( diffuse = mat_diffuse, specular = mat_specular, 
                               shininess = mat_shininess ), matrix )

    matrix = rotation_matrix(  math.pi * ( 75.0/180.0 ), [0.0, 1.0, 0.0])[:3, :3]
    matrix = numpy.dot( rotation_matrix( math.pi/9.0, [0.0, 0.0, 1.0])[:3, :3], matrix )
    torus2 = Torus( 60.0, 10.0, [0.0, -50.0, -630.5],
                     Material( diffuse = mat_diffuse, specular = mat_specular, 
                               shininess = mat_shininess ), matrix )

    print torus
    scene_graph = SceneGraph( [ torus2, torus ], [ light ] )

    return scene_graph
