def testRectTexturing():
    texture = Texture('./rc_out.png')
    w, h = 2.0, 2.0
    rect = Rect( numpy.array([0.0, 0.0, 0.0]), 
                 numpy.array([1.0, 0.0, 0.0]), 
                 numpy.array([0.0, 1.0, 0.0]), 
                 w, h, 
                 texture = texture )
    
    print texture.image.size
    xres, yres = texture.image.size
    alphas = numpy.array( xrange(0, xres, 1) )
    betas  = numpy.array( xrange(0, yres, 1) )

    outfile = PIL.Image.new( 'RGB', texture.image.size )

    for x in alphas:
        for y in betas:
            px = ( x * w ) / float( xres )  
            py = ( y * h ) / float( yres )
            pt = numpy.array( [ px, py, 0.0 ] )
            c = rect.render( pt, None, None )
            outfile.putpixel( (x, y), tuple( ( 255 * c ).astype( int ) ) )
    outfile.save( './result.png' )

def testPointInRect():
    
    ray = Ray( numpy.array([ 2.0, 0.0, -1.0 ] ), numpy.array( [ -1.0, 1.0, 1.0 ] ), ( 0, 0 ), ( 0, 0 ) ) 
    rect = Rect( numpy.array([0.0, 0.0, 0.0]), numpy.array([1.0, 0.0, 0.0]), numpy.array([0.0, 1.0, 0.0]), 2.0, 2.0 )


    pt = rect.intersect( ray )
    print ray
    print pt 
    ray = Ray( numpy.array([ 2.0, 0.0, -1.0 ] ), numpy.array( [ -10.0, 1.0, 1.0 ] ), ( 0, 0 ), ( 0, 0 ) ) 
    pt = rect.intersect( ray )
    print ray
    print pt 

    p1 = numpy.array([-1.0, 1.0, 0.0])
    p2 = numpy.array([ 1.0, 3.0, 0.0])
    p3 = numpy.array([ 3.0, 1.0, 0.0])
    p4 = numpy.array([ 1.0, -1.0, 0.0])
    p5 = numpy.array([ -1.0, 3.0, 0.0])
    p6 = numpy.array([ 3.0, 3.0, 0.0])
    p7 = numpy.array([ 3.0, -1.0, 0.0])
    p8 = numpy.array([ -1.0, -1.0, 0.0])
    p9 = numpy.array([ 1.0, 1.0, 0.0])
    print p1, rect.pointInRect( p1 )
    print p2, rect.pointInRect( p2 )
    print p3, rect.pointInRect( p3 )
    print p4, rect.pointInRect( p4 )
    print p5, rect.pointInRect( p5 )
    print p6, rect.pointInRect( p6 )
    print p7, rect.pointInRect( p7 )
    print p8, rect.pointInRect( p8 )
    print p9, rect.pointInRect( p9 )

def testTorus():

    t = Torus( 10.0, 2.0 )

    ray = Ray( numpy.array([ 0.0, 0.0, 0.0 ] ), numpy.array( [ 0.0, 1.0, 0.0 ] ), ( 0, 0 ), ( 0, 0 ) ) 
    hit = t.intersect( ray )
    print hit
    print t.normalAt( hit.point )

    ray = Ray( numpy.array([ 0.0, 0.0, 0.0 ] ), numpy.array( [ 1.0, 0.0, 0.0 ] ), ( 0, 0 ), ( 0, 0 ) ) 
    hit = t.intersect( ray )
    print hit
    print t.normalAt( hit.point )

    ray = Ray( numpy.array([ 10.0, 0.0, 0.0 ] ), numpy.array( [ 0.0, 0.0, -1.0 ] ), ( 0, 0 ), ( 0, 0 ) ) 
    hit = t.intersect( ray )
    print hit
    print t.normalAt( hit.point )

    matrix = rotation_matrix(math.pi/2.0, [1.0, 0.0, 0.0])[:3, :3]
    t = Torus( 10.0, 2, transform=matrix )

    ray = Ray( numpy.array([ 0.0, 0.0, 0.0 ] ), numpy.array( [ 0.0, 0.0, -1.0 ] ), ( 0, 0 ), ( 0, 0 ) ) 
    hit = t.intersect( ray )
    print 'hit => %s' % hit
    print t.normalAt( hit.point )

def testMetaballs():

    b1 = Metaballs.Ball( numpy.array( [ -20.0, 0.0, -100.0 ] ), 30.0 )
    b2 = Metaballs.Ball( numpy.array( [ 20.0, 0.0, -100.0 ] ), 30.0 )
    m = Metaballs( [b1, b2], 0.4 )
    ray = Ray( numpy.array( [10.0, 0.0, 0.0] ), numpy.array([ 0.0, 0.0, -1.0 ] ), None, None )
    m.intersect( ray )
    
    #pt = numpy.array( [5.0, 0.0, -100.0] )
    #print m.fn( pt )